/*
  Copyright 2013-2014 Jan Adamec, Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
*/

#import <Foundation/Foundation.h>
#import <GLKit/GLKit.h>
#import "ViewpointsController.h"
#import "FileOpenController.h"

@interface OpenGLController : GLKViewController<UIPopoverControllerDelegate>
{
    ViewpointsController *m_viewpointsController;
    FileOpenController *m_fileOpenController;
    UIPopoverController *m_currentPopover;
}

@property (nonatomic, strong) NSString* fileToOpen;

- (IBAction)OnTouchGesture:(UITapGestureRecognizer *)sender;
- (IBAction)OnPanGesture:(UIPanGestureRecognizer *)sender;
- (IBAction)OnPinchGesture:(UIPinchGestureRecognizer *)sender;


@end
